]> git.donarmstrong.com Git - debhelper.git/blobdiff - Debian/Debhelper/Dh_Lib.pm
r1987: * Do script fragement reversal only in v6, since it can break certian
[debhelper.git] / Debian / Debhelper / Dh_Lib.pm
index 0eea0180f40f9195ffcbb04e452e94105f2f1585..c72e559f44e676d69586e8373cf233d6b7955f88 100644 (file)
@@ -12,10 +12,11 @@ use vars qw(@ISA @EXPORT %dh);
 @ISA=qw(Exporter);
 @EXPORT=qw(&init &doit &complex_doit &verbose_print &error &warning &tmpdir
            &pkgfile &pkgext &pkgfilename &isnative &autoscript &filearray
-           &filedoublearray &GetPackages &basename &dirname &xargs %dh
-           &compat &addsubstvar &delsubstvar &excludefile);
+           &filedoublearray &getpackages &basename &dirname &xargs %dh
+           &compat &addsubstvar &delsubstvar &excludefile &package_arch
+           &is_udeb &udeb_filename &debhelper_script_subst &escape_shell);
 
-my $max_compat=4;
+my $max_compat=6;
 
 sub init {
        # If DH_OPTIONS is set, prepend it @ARGV.
@@ -54,8 +55,8 @@ sub init {
                foreach (@{$dh{EXCLUDE}}) {
                        my $x=$_;
                        $x=escape_shell($x);
-                       $x=~s/\./\\./g;
-                       $dh{EXCLUDE_FIND}.="-regex .*$x.* -or ";
+                       $x=~s/\./\\\\./g;
+                       $dh{EXCLUDE_FIND}.="-regex .\\*$x.\\* -or ";
                }
                $dh{EXCLUDE_FIND}=~s/ -or $//;
        }
@@ -72,7 +73,7 @@ sub init {
                $dh{NO_ACT}=1;
        }
 
-       my @allpackages=GetPackages();
+       my @allpackages=getpackages();
        # Get the name of the main binary package (first one listed in
        # debian/control). Only if the main package was not set on the
        # command line.
@@ -99,6 +100,12 @@ sub init {
        # This package gets special treatement: files and directories specified on
        # the command line may affect it.
        $dh{FIRSTPACKAGE}=${$dh{DOPACKAGES}}[0];
+
+       # If no error handling function was specified, just propigate
+       # errors out.
+       if (! exists $dh{ERROR_HANDLER} || ! defined $dh{ERROR_HANDLER}) {
+               $dh{ERROR_HANDLER}='exit \$?';
+       }
 }
 
 # Pass it an array containing the arguments of a shell command like would
@@ -238,25 +245,43 @@ sub dirname {
 
 # Pass in a number, will return true iff the current compatibility level
 # is less than or equal to that number.
-sub compat {
-       my $num=shift;
+{
+       my $warned_compat=0;
+       my $c;
+
+       sub compat {
+               my $num=shift;
        
-       my $c=1;
-       if (defined $ENV{DH_COMPAT}) {
-               $c=$ENV{DH_COMPAT};
-       }
-       elsif (-e 'debian/compat') {
-               # Try the file..
-               open (COMPAT_IN, "debian/compat") || error "debian/compat: $!";
-               $c=<COMPAT_IN>;
-               chomp $c;
-       }
+               if (! defined $c) {
+                       $c=1;
+                       if (defined $ENV{DH_COMPAT}) {
+                               $c=$ENV{DH_COMPAT};
+                       }
+                       elsif (-e 'debian/compat') {
+                               # Try the file..
+                               open (COMPAT_IN, "debian/compat") || error "debian/compat: $!";
+                               my $l=<COMPAT_IN>;
+                               if (! defined $l || ! length $l) {
+                                       warning("debian/compat is empty, assuming level $c");
+                               }
+                               else {
+                                       chomp $l;
+                                       $c=$l;
+                               }
+                       }
+               }
 
-       if ($c > $max_compat) {
-               error("Sorry, but $max_compat is the highest compatibility level of debhelper currently supported.");
-       }
+               if ($c < 4 && ! $warned_compat) {
+                       warning("Compatibility levels before 4 are deprecated.");
+                       $warned_compat=1;
+               }
+       
+               if ($c > $max_compat) {
+                       error("Sorry, but $max_compat is the highest compatibility level supported by this debhelper.");
+               }
 
-       return ($c <= $num);
+               return ($c <= $num);
+       }
 }
 
 # Pass it a name of a binary package, it returns the name of the tmp dir to
@@ -380,7 +405,7 @@ sub autoscript {
        my $filename=shift;
        my $sed=shift || "";
 
-       # This is the file we will append to.
+       # This is the file we will modify.
        my $outfile="debian/".pkgext($package)."$script.debhelper";
 
        # Figure out what shell script snippet to use.
@@ -398,9 +423,20 @@ sub autoscript {
                }
        }
 
-       complex_doit("echo \"# Automatically added by ".basename($0)."\">> $outfile");
-       complex_doit("sed \"$sed\" $infile >> $outfile");
-       complex_doit("echo '# End automatically added section' >> $outfile");
+       if (-e $outfile && ($script eq 'postrm' || $script eq 'prerm')
+          && !compat(5)) {
+               # Add fragments to top so they run in reverse order when removing.
+               complex_doit("echo \"# Automatically added by ".basename($0)."\"> $outfile.new");
+               complex_doit("sed \"$sed\" $infile >> $outfile.new");
+               complex_doit("echo '# End automatically added section' >> $outfile.new");
+               complex_doit("cat $outfile >> $outfile.new");
+               complex_doit("mv $outfile.new $outfile");
+       }
+       else {
+               complex_doit("echo \"# Automatically added by ".basename($0)."\">> $outfile");
+               complex_doit("sed \"$sed\" $infile >> $outfile");
+               complex_doit("echo '# End automatically added section' >> $outfile");
+       }
 }
 
 # Removes a whole substvar line.
@@ -479,6 +515,11 @@ sub filedoublearray {
        my @ret;
        open (DH_FARRAY_IN, $file) || error("cannot read $file: $1");
        while (<DH_FARRAY_IN>) {
+               chomp;
+               # Only ignore comments and empty lines in v5 mode.
+               if (! compat(4)) {
+                       next if /^#/ || /^$/;
+               }
                my @line;
                # Only do glob expansion in v3 mode.
                #
@@ -523,18 +564,36 @@ sub excludefile {
        sub buildarch {
                return $arch if defined $arch;
 
-               $arch=`dpkg-architecture -qDEB_HOST_ARCH 2>/dev/null` || error($!);
+               $arch=`dpkg-architecture -qDEB_HOST_ARCH 2>/dev/null` || error("dpkg-architecture failed");
                chomp $arch;
                return $arch;
        }
 }
 
+# Passed an arch and a list of arches to match against, returns true if matched
+sub samearch {
+       my $arch=shift;
+       my @archlist=split(/\s+/,shift);
+
+       foreach my $a (@archlist) {
+               system("dpkg-architecture", "-a$arch", "-i$a") == 0 && return 1;
+       }
+
+       return 0;
+}
+
 # Returns a list of packages in the control file.
 # Must pass "arch" or "indep" or "same" to specify arch-dependant or
 # -independant or same arch packages. If nothing is specified, returns all
 # packages.
-sub GetPackages {
+# As a side effect, populates %package_arches and %package_types with the
+# types of all packages (not only those returned).
+my (%package_types, %package_arches);
+sub getpackages {
        my $type=shift;
+
+       %package_types=();
+       %package_arches=();
        
        $type="" if ! defined $type;
        
@@ -546,6 +605,7 @@ sub GetPackages {
 
        my $package="";
        my $arch="";
+       my $package_type;
        my @list=();
        my %seen;
        open (CONTROL, 'debian/control') ||
@@ -562,16 +622,24 @@ sub GetPackages {
                        else {
                                error("debian/control has a duplicate entry for $package");
                        }
+                       $package_type="deb";
                }
                if (/^Architecture:\s*(.*)/) {
                        $arch=$1;
                }
+               if (/^(?:X[BC]*-)?Package-Type:\s*(.*)/) {
+                       $package_type=$1;
+               }
                
                if (!$_ or eof) { # end of stanza.
+                       if ($package) {
+                               $package_types{$package}=$package_type;
+                               $package_arches{$package}=$arch;
+                       }
                        if ($package &&
                            (($type eq 'indep' && $arch eq 'all') ||
                             ($type eq 'arch' && $arch ne 'all') ||
-                            ($type eq 'same' && ($arch eq 'any' || $arch =~ /\b$buildarch\b/)) ||
+                            ($type eq 'same' && ($arch eq 'any' || samearch($buildarch, $arch))) ||
                             ! $type)) {
                                push @list, $package;
                                $package="";
@@ -584,4 +652,59 @@ sub GetPackages {
        return @list;
 }
 
+# Returns the arch a package will build for.
+sub package_arch {
+       my $package=shift;
+       
+       return $package_arches{$package} eq 'all' ? "all" : buildarch();
+}
+
+# Return true if a given package is really a udeb.
+sub is_udeb {
+       my $package=shift;
+       
+       return $package_types{$package} eq 'udeb';
+}
+
+# Generates the filename that is used for a udeb package.
+sub udeb_filename {
+       my $package=shift;
+       
+       my $filearch=package_arch($package);
+       isnative($package); # side effect
+       my $version=$dh{VERSION};
+       $version=~s/^[0-9]+://; # strip any epoch
+       return "${package}_${version}_$filearch.udeb";
+}
+
+# Handles #DEBHELPER# substitution in a script; also can generate a new
+# script from scratch if none exists but there is a .debhelper file for it.
+sub debhelper_script_subst {
+       my $package=shift;
+       my $script=shift;
+       
+       my $tmp=tmpdir($package);
+       my $ext=pkgext($package);
+       my $file=pkgfile($package,$script);
+
+       if ($file ne '') {
+               if (-f "debian/$ext$script.debhelper") {
+                       # Add this into the script, where it has #DEBHELPER#
+                       complex_doit("perl -pe 's~#DEBHELPER#~qx{cat debian/$ext$script.debhelper}~eg' < $file > $tmp/DEBIAN/$script");
+               }
+               else {
+                       # Just get rid of any #DEBHELPER# in the script.
+                       complex_doit("sed s/#DEBHELPER#// < $file > $tmp/DEBIAN/$script");
+               }
+               doit("chown","0:0","$tmp/DEBIAN/$script");
+               doit("chmod",755,"$tmp/DEBIAN/$script");
+       }
+       elsif ( -f "debian/$ext$script.debhelper" ) {
+               complex_doit("printf '#!/bin/sh\nset -e\n' > $tmp/DEBIAN/$script");
+               complex_doit("cat debian/$ext$script.debhelper >> $tmp/DEBIAN/$script");
+               doit("chown","0:0","$tmp/DEBIAN/$script");
+               doit("chmod",755,"$tmp/DEBIAN/$script");
+       }
+}
+
 1